

/*
		MemoryBlock.InByte, InRevByte, InSegBlock, InBlock, InCharSet, OutCharSet, SetSize;
		Global StringToPointer, MidAscB, ByteOfString, InCharSet, OutCharSet, InByte, EmptyString, FastInStrB
		functions by "Theo", <http://www.thsmith.dircon.co.uk/> <delete@softhome.net>

 Oct 28, 2000, v1.0
 Aug 11, 2000, v1.201

I did some tests on speed, and it seems that adding a long that happens to be 1 or -1, to another variable
is just as fast as doing ++ or --

Also, it seems that without inlining, that calling one function from inside another is just as fast
as putting one function's code inside the other.....

The slowest part often seems to be RB's overhead in calling the plugin, passing values and returning them.

 */
 
 

#ifndef WIN32
	#include <MacMemory.h>
#endif

#include "rb_plugin.h"

typedef long* byreflong;
typedef const char cnst;
typedef unsigned const char ucnst;
typedef unsigned char uchar;

long kFirst =  0;
long kBack  = -1;
long kFore  =  1;
long kEnd   = -1;

extern REALclassDefinition memBlkClass;





        /* InLines */

static inline uchar* MBPtr (REALobject self) {
 return *(uchar**)((uchar*)self + 0x1C); }

static inline long MBSize (REALobject self) {
 return *(long*)((long)self + 0x18); }

static inline void setMBSize (REALobject self, long NewSize) {
 *(long*)((long)self + 0x18) = NewSize; }

static inline uchar* SearchContainerUptil(uchar* CharPos, long Finish, long ContainerLength) { //Finish 0 based, CLength 1 based, result 1 based
 if (Finish < 0 || Finish >= ContainerLength)
  return (uchar*)(CharPos + ContainerLength);
 else
  return (uchar*)(CharPos + Finish + 1); }

static inline void CharPosAndContainerEndHandler(byreflong CharPos, byreflong ContainerEnd, byreflong dirlong) {
   if (*dirlong == 1) {
    if (*CharPos > *ContainerEnd)
     *CharPos = *ContainerEnd;
  } else {
    long TempCharPos = *CharPos - 1;
    *CharPos = *ContainerEnd - 1;
    *ContainerEnd = TempCharPos;
    if (*ContainerEnd > *CharPos)
     *CharPos = *ContainerEnd;
  }
}




         /*       Main subs       */

static long	outcmainsub(uchar *CharPos, long BeginPos, long EndPos, uchar *CharSetOffset, long LenBString, long LenBCharSet, long dirlong) {
 register ucnst		*CharSetPos;
 ucnst				*FirstCharPos;
 uchar				*CharSetEnd;
 uchar				*SearchEnd;

 if (LenBString && LenBCharSet) {
  FirstCharPos = CharPos;
  SearchEnd = SearchContainerUptil(CharPos, EndPos, LenBString);
  CharSetEnd = (uchar*)((long)CharSetOffset + LenBCharSet);
  if (BeginPos > 0) CharPos += BeginPos;
  CharPosAndContainerEndHandler((byreflong)&CharPos, (byreflong)&SearchEnd, (byreflong)&dirlong);
  for (CharPos; CharPos != SearchEnd; CharPos += dirlong) {
   for (CharSetPos = (uchar*)CharSetOffset; CharSetPos != CharSetEnd; CharSetPos++) {
    if (*CharSetPos == *CharPos) goto EndLoop;
   }
   return (long)(CharPos - FirstCharPos);
   EndLoop: ;
  }
 }
 return -1;
}


static long	incmainsub (uchar *CharPos, long BeginPos, long EndPos, uchar *CharSetOffset, long LenBString, long LenBCharSet, long *csresult, long dirlong) {
 ucnst				*FirstCharPos;
 register uchar		*CharSetPos;
 uchar				*CharSetEnd;
 uchar				*SearchEnd;

 if (LenBString && LenBCharSet) {
  FirstCharPos = CharPos ;
  SearchEnd = SearchContainerUptil(CharPos, EndPos, LenBString) ;
  CharSetEnd = (uchar*)((long)CharSetOffset + LenBCharSet) ;
  if (BeginPos > 0) CharPos += BeginPos;
  CharPosAndContainerEndHandler((byreflong)&CharPos, (byreflong)&SearchEnd, (byreflong)&dirlong);
  for (CharPos; CharPos != SearchEnd; CharPos+= dirlong) {
   for (CharSetPos = (uchar*)CharSetOffset; CharSetPos != CharSetEnd; CharSetPos++) {
    if (*CharSetPos == *CharPos) {
     *csresult = CharSetPos - CharSetOffset;
     return (long)(CharPos - FirstCharPos) ;
    }
   }
  }
 }
 return -1;
}



static long inblockmainsub(uchar *CharPos, long BeginPos, long EndPos, uchar *SearchStart, long BeginSear, long EndSear, long ContainerLength, long SearchLength, long dirlong) {
 register uchar		*SearchPos;
 register uchar		FirstChar;
 register uchar		*TempCharPos;
 uchar				*FirstCharPos;
 uchar				*SearchEnd;
 uchar				*ContainerEnd;
  
 if ( ContainerLength ) {
  FirstCharPos = CharPos;
  SearchEnd = SearchContainerUptil(SearchStart, EndSear, SearchLength);
  if ( SearchEnd >= SearchStart ) {
   if (BeginSear > 0) SearchStart += BeginSear;
   SearchLength = SearchEnd - SearchStart;
   ContainerLength += SearchLength;
   ContainerEnd = SearchContainerUptil(CharPos, EndPos, ContainerLength);
   if (BeginPos > 0) CharPos += BeginPos;
   CharPosAndContainerEndHandler((byreflong)&CharPos, (byreflong)&ContainerEnd, (byreflong)&dirlong);
   FirstChar = *SearchStart;
   SearchStart++;
   for (CharPos; CharPos != ContainerEnd; CharPos += dirlong) {
    if (FirstChar == *CharPos) {
     TempCharPos = CharPos + 1;
     for (SearchPos = SearchStart; SearchPos != SearchEnd;) {
      if (*SearchPos++ != *TempCharPos++) goto DidntMatch;
     }
     return (long)CharPos - long(FirstCharPos);
     DidntMatch: ;
    }
   }
  }
 }
 return -1;
}



static long inbytemainsub(uchar *CharPos, long ContainerLength, long BeginPos, long EndPos, long SearchByteParam, long dirlong) {
 register uchar		SearchByte;
 uchar				*SearchEnd;
 uchar				*FirstCharPos;
 
 if (ContainerLength) {
  
  FirstCharPos = CharPos;
  SearchEnd = SearchContainerUptil(CharPos, EndPos, ContainerLength);
  if (BeginPos > 0) CharPos += BeginPos;
  CharPosAndContainerEndHandler((byreflong)&CharPos, (byreflong)&SearchEnd, (byreflong)&dirlong);
  SearchByte = (uchar)SearchByteParam;
  for (CharPos; CharPos != SearchEnd; CharPos += dirlong) {
   if (SearchByte == *CharPos) {return (long)CharPos - long(FirstCharPos);}
  }
 }
 return -1;
}


static long InRange(REALobject instance, long BeginPos, long EndPos, long RangeStart, long RangeEnd) {
  register uchar	*CharPos = MBPtr(instance);
  uchar				*StartPos;
  long				ContainerLength = MBSize(instance);
  register uchar	*ContainerEnd;
  long				templong;
  StartPos = CharPos;
  
  if ( ContainerLength ) {
   	ContainerEnd = SearchContainerUptil(CharPos, EndPos, ContainerLength);
   	if (BeginPos > 0) CharPos += BeginPos;
	for (CharPos; CharPos < ContainerEnd; CharPos++) {
		templong = long(*CharPos);
		if ( templong < RangeStart || templong > RangeEnd) return (CharPos - StartPos);
	}
 }
 return -1;
}





/* String functions. */

static long	OutCSStr(REALstring MyString, long BeginPos, long EndPos, REALstring CharSet) {
 return 1 + outcmainsub((uchar*)MyString->CString(), BeginPos-1, EndPos-1, (uchar*)CharSet->CString(), MyString->Length(), CharSet->Length(), kFore); }

static long	OutRevCSStr(REALstring MyString, long BeginPos, long EndPos, REALstring CharSet) {
 return 1 + outcmainsub((uchar*)MyString->CString(), BeginPos-1, EndPos-1, (uchar*)CharSet->CString(), MyString->Length(), CharSet->Length(), kBack); }

static long	InCSStr(REALstring MyString, long BeginPos, long EndPos, REALstring CharSet) {
 long dummy;
 return 1 + incmainsub((uchar*)MyString->CString(), BeginPos-1, EndPos-1, (uchar*)CharSet->CString(), MyString->Length(), CharSet->Length(), &dummy, kFore); }

static long FastInStrB(long BeginPos, long EndPos, REALstring MyString, REALstring pattern) {
 return 1 + inblockmainsub( (uchar*)MyString->CString(), BeginPos-1, EndPos-1, (uchar*)pattern->CString(), kFirst, kEnd, MyString->Length(), pattern->Length(), kFore ); }

static long InByteStr(long BeginPos, long EndPos, REALstring MyString, long pByte) {
 return 1 + inbytemainsub((uchar*)MyString->CString(), MyString->Length(), BeginPos-1, EndPos-1, pByte, kFore); }

static long StrToPointer(REALstring mystring) {
 return (long)(mystring->CString()); }

static long MidAscB(REALstring mystring, long offset) {
 return (long)(*(uchar*)((long)(mystring->CString()) + offset - 1)); }

static long ByteOfString(REALstring mystring, long offset) {
 return (long)(*(uchar*)((long)(mystring->CString()) + offset)); }

static REALstring EmptyString(long TheLength, long pChar) {
 REALstring resultstring = REALBuildString (0, (TheLength > -1 ? TheLength : 0));
 if (TheLength > 0 && pChar > -1 && pChar < 256) {
  	uchar *charpos = (uchar*)resultstring->CString(), *resultend = charpos + TheLength;
  	uchar TheChar = (uchar)pChar;
  	for (charpos; charpos < resultend; charpos++) {
  		*charpos = TheChar;
  	}
  }
 return resultstring;
}



           /* Memoryblock methods */

static long InBlock(REALobject self, long BeginPos, long EndPos, REALobject SearchMB) {
 return inblockmainsub( MBPtr(self), BeginPos, EndPos, MBPtr(SearchMB), kFirst, kEnd, MBSize(self), MBSize(SearchMB), kFore ); }
 
static long InRevBlock(REALobject self, long BeginPos, long EndPos, REALobject SearchMB) {
 return inblockmainsub( MBPtr(self), BeginPos, EndPos, MBPtr(SearchMB), kFirst, kEnd, MBSize(self), MBSize(SearchMB), kBack ); }

static long ExpertInBlock(REALobject self, long BeginPos, long EndPos, REALobject SearchMB, long BeginSear, long EndSear, Boolean dir) {
 return inblockmainsub( MBPtr(self), BeginPos, EndPos, MBPtr(SearchMB), BeginSear, EndSear, MBSize(self), MBSize(SearchMB), (dir ? kFore : kBack)); }

static long InByteMB(REALobject self, long BeginPos, long EndPos, long SearchByteParam) {
 return inbytemainsub( MBPtr(self), MBSize(self), BeginPos, EndPos, SearchByteParam, kFore); }

static long InRevByteMB(REALobject self, long BeginPos, long EndPos, long SearchByteParam) {
 return inbytemainsub( MBPtr(self), MBSize(self), BeginPos, EndPos, SearchByteParam, kBack); }

static long OutCSMB(REALobject self, long BeginPos, long EndPos, REALobject CharSetMB) {
 return outcmainsub(MBPtr(self), BeginPos, EndPos, MBPtr(CharSetMB), MBSize(self), MBSize(CharSetMB), kFore); }

static long	InCSMB(REALobject self, long BeginPos, long EndPos, REALobject CharSetMB, long *charsetresult) {
 return incmainsub(MBPtr(self), BeginPos, EndPos, MBPtr(CharSetMB), MBSize(self), MBSize(CharSetMB), charsetresult, kFore); }

static void SetMBSize(REALobject self, long NewSize) {
 setMBSize(self, NewSize); }
 
//static void SetMBColor(REALobject self, long offset, long TheColor/*A cheat, but it works*/) {
// *(long*)(MBPtr(self) + offset) = TheColor; }
 
//static long GetMBColor(REALobject self, long offset) {
//return *(long*)(MBPtr(self) + offset); }


            /* Plugin glue code */

static REALmethodDefinition memBlkClassMethods[] = {
	{ (REALproc) OutCSMB,  			REALnoImplementation, "OutCharSet(Start as Integer, Finish as Integer, CharSet as MemoryBlock) as Integer"},
	{ (REALproc) InCSMB,  			REALnoImplementation, "InCharSet(Start as Integer, Finish as Integer, CharSet as MemoryBlock, byref CharSetPos as Integer) as Integer"},
	{ (REALproc) InRange,  			REALnoImplementation, "InRange(Start as Integer, Finish as Integer, RangeStart as integer, RangeEnd as integer) as Integer"},
	{ (REALproc) InBlock,			REALnoImplementation, "InBlock(Start as Integer, Finish as Integer, Search as MemoryBlock) as Integer"},
	{ (REALproc) InRevBlock,		REALnoImplementation, "InRevBlock(Start as Integer, Finish as Integer, Search as MemoryBlock) as Integer"},
	{ (REALproc) ExpertInBlock,		REALnoImplementation, "InSegBlock(Start as Integer, Finish as Integer, Search as MemoryBlock, SrStart as integer, SrFinish as Integer, Forward as Boolean) as Integer"},
	{ (REALproc) InByteMB, 		 	REALnoImplementation, "InByte(Start as Integer, Finish as Integer, Byte as Integer) as Integer"},
	{ (REALproc) InRevByteMB,		REALnoImplementation, "InRevByte(Start as Integer, Finish as Integer, Byte as Integer) as Integer"},
	{ (REALproc) SetMBSize,			REALnoImplementation, "SetSize(Size as Integer)" },
//	{ (REALproc) GetMBColor,		(REALproc)SetMBColor, "Color(Offset as Integer) as Color"},
};

static REALmethodDefinition pluginMethodArray[] = {
	{ (REALproc) EmptyString,		REALnoImplementation, "EmptyString(Length as Integer, CharVal as integer) as String" },
	{ (REALproc) FastInStrB,		REALnoImplementation, "FastInStrB(Start as Integer, Finish as integer, Container as String, Find as string) as Integer" },
	{ (REALproc) InByteStr,			REALnoImplementation, "InByte(Start as Integer, Finish as integer, Container as String, Byte as Integer) as Integer" },
	{ (REALproc) OutCSStr,			REALnoImplementation, "OutCharSet(Container as String, Start as Integer, Finish as Integer, CharSet as String) as Integer" },
	{ (REALproc) OutRevCSStr,		REALnoImplementation, "OutRevCharSet(Container as String, Start as Integer, Finish as Integer, CharSet as String) as Integer" },
	{ (REALproc) InCSStr,			REALnoImplementation, "InCharSet(Container as String, Start as Integer, Finish as Integer, CharSet as String) as Integer" },
	{ (REALproc) MidAscB,			REALnoImplementation, "MidAscB(Container as String, Offset as Integer) as Integer" },
	{ (REALproc) ByteOfString,		REALnoImplementation, "ByteOfString(Container as String, Offset as Integer) as Integer" },
	{ (REALproc) StrToPointer,		REALnoImplementation, "StringToPointer(TheString as String) as Integer" },
};



            /* Wierd Stuff I still don't get yet */

static REALclassDefinition memBlkClass = {
	kCurrentREALControlVersion,
	"MemoryBlock",
	nil,
	0,
	0,
	(REALproc) nil,
	(REALproc) nil,
	nil,
	nil,
	memBlkClassMethods,
	sizeof(memBlkClassMethods) / sizeof(REALmethodDefinition),
	nil,
	0
};

void PluginEntry (void)
{
	for (int i = 0; i < sizeof(pluginMethodArray) / sizeof(REALmethodDefinition); ++i) {
		REALRegisterMethod (&pluginMethodArray[i]);
	}	
	REALRegisterClassExtension (&memBlkClass);
}
